<?php

/**
 * novedad_devengado actions.
 *
 * @package    nomina
 * @subpackage novedad_devengado
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class novedad_devengadoActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'NO_NOV_DED_ADIC',
        'NO_TIPO_NOV_DED_ADIC',
        'NO_DATOS_FUNCIONARIO_V',
        'NO_PERIODO_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'NO_TIPO_NOV_DED_ADIC' =>
        array(
            'id_tipo_nov_ded_adic' => 'NO_NOV_DED_ADIC'
        ),
        'NO_DATOS_FUNCIONARIO_V' =>
        array(
            'id_tipo_doc' => 'NO_NOV_DED_ADIC',
            'num_doc' => 'NO_NOV_DED_ADIC'
        ),
        'NO_PERIODO_V' =>
        array(
            'id_periodo' => 'NO_NOV_DED_ADIC'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'NO_NOV_DED_ADIC' =>
        array(
            'id_nov_dec_adic' => 'id_nov_dec_adic',
            'id_tipo_doc' => 'id_tipo_doc',
            'num_doc' => 'num_doc',
            'id_tipo_nov_ded_adic' => 'id_tipo_nov_ded_adic',
            'fecha_ini' => 'fecha_ini',
            'fecha_fin' => 'fecha_fin',
            'tipo_doc_sop' => 'tipo_doc_sop',
            'num_doc_sop' => 'num_doc_sop',
            'fecha_doc_sop' => 'fecha_doc_sop',
            'tipo_doc_cierre' => 'tipo_doc_cierre',
            'num_doc_cierre' => 'num_doc_cierre',
            'fecha_doc_cierre' => 'fecha_doc_cierre',
            'observaciones_cierre' => 'observaciones_cierre',
            'id_periodo' => 'id_periodo',
            'estado' => 'estado'
        ),
        'NO_TIPO_NOV_DED_ADIC' =>
        array(
            'codigo' => 'codigo_novedad',
            'descripcion' => 'descripcion_novedad',
            'codigo,||, - ,||,descripcion' => 'completo_novedad'
        ),
        'NO_DATOS_FUNCIONARIO_V' =>
        array(
            'nombre_completo' => 'nombre_completo'
        ),
        'NO_PERIODO_V' =>
        array(
            'id_meses' => 'id_meses',
            'id_anhos' => 'id_anhos',
            'periodo' => 'periodo'
        )
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'NO_NOV_DED_ADIC' => array(
            'id_nov_dec_adic,a' => array('!=' => array(-1)),
            'id_nov_dec_adic,b' => array('=' => array('id_nov_dec_adic')),
            'id_tipo_nov_ded_adic' => array('=' => array('id_novedad')),
            'num_doc' => array('=' => array('num_doc')),
            'id_tipo_doc' => array('=' => array('id_tipo_doc')),
            'id_periodo' => array('=' => array('id_periodo_filtro')),
            'estado' => array('=' => array('estado')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(); // filtros de condicion or
    protected $fields_orderBy = array(
        'nombre_completo', 'fecha_ini'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Area';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;


    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_nov_dec_adic'; //identificador de la tabla
    protected $id_names = array('id_nov_dec_adic'); //llave primaria
    protected $field_names = array('id_tipo_doc', 'num_doc', 'id_tipo_nov_ded_adic', 'fecha_ini', 'fecha_fin', 'tipo_doc_sop', 'num_doc_sop', 'fecha_doc_sop',
        'tipo_doc_cierre', 'num_doc_cierre', 'fecha_doc_cierre', 'observaciones_cierre', 'id_periodo', 'estado'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'NO_NOV_DED_ADIC'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_nov_dec_adic'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     * Se agrega opcion de elimnar - 20150316
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */
        $id_nov_dec_adic = $request['id_nov_dec_adic'];
        $id_periodo = $request['id_periodo'];

        /*
         * Validar que sea en el mismo periodo de registro
         */
        $sql = <<<EOD
SELECT * FROM NO_NOV_DED_ADIC WHERE id_nov_dec_adic = $id_nov_dec_adic
EOD;

        $results = CN_TABLE::executeSQL($sql);

        $id_periodo_nov = $results[0]['id_periodo'];

        /*
         *  Generar errores en $errors
         */
        if ($id_periodo != $id_periodo_nov) {
            $errors['mensaje'] = "La novedad de devengado adicional no corresponde al periodo en el cual esta ejecutando la nómina actual. Favor Verificar antes de Eliminar.";
            $errors['servicio'] = "novedad_devengado";
        }

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            /*
             * Forzar formato de fecha para manejo en el postprocess
             */
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            CN_TABLE::executeSQL($sql);
        }

        //accion remove
        if ($Action == "REMOVE") {


            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();


            /*
             * Forzar formato de fecha para manejo en el postprocess
             */
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            CN_TABLE::executeSQL($sql);

            /**
             * Se eliminan registros de no_nov_concepto - 20150316
             */
            $id_nov_dec_adic = $request['id_nov_dec_adic'];

            $sql = <<<EOD
SELECT * FROM NO_NOV_DED_ADIC WHERE id_nov_dec_adic = $id_nov_dec_adic
EOD;

            $results = CN_TABLE::executeSQL($sql);

            $id_periodo_nov = $results[0]['id_periodo'];
            $id_tipo_doc = $results[0]['id_tipo_doc'];
            $num_doc = $results[0]['num_doc'];
            $fecha_desde = $results[0]['fecha_ini'];

            try {

                $sql = <<<EOD
SELECT * FROM NO_NOV_CONCEPTO WHERE ID_NOV_DED_ADIC = $id_nov_dec_adic 
EOD;
                $results = CN_TABLE::executeSQL($sql);

                if (count($results) > 0) {

                    foreach ($results as $conceptos) {

                        $id_concep_nomina = $conceptos['id_concep_nomina'];

                        //concepto_func
                        $sql = <<<EOD
DELETE FROM NO_CONCEPTO_FUNC WHERE id_concep_nomina = $id_concep_nomina
    and id_tipo_doc = $id_tipo_doc and num_doc = $num_doc
    and fecha_desde = to_date('$fecha_desde','YYYY-MM-DD')                                
EOD;
                        $this->conn->execute($sql);

                        //concepto periodo
                        $sql = <<<EOD
DELETE FROM NO_CONCEPTO_PERIODO WHERE id_concep_nomina = $id_concep_nomina
    and id_tipo_doc = $id_tipo_doc and num_doc = $num_doc
    and periodo = $id_periodo_nov                                
EOD;
                        $this->conn->execute($sql);

                        //liquida nomina
                        $sql = <<<EOD
DELETE FROM NO_LIQUIDA_NOMINA WHERE id_concep_nomina = $id_concep_nomina
    and id_tipo_doc = $id_tipo_doc and num_doc = $num_doc
    and id_periodo = $id_periodo_nov
EOD;
                        $this->conn->execute($sql);
                    }
                }

                $sql = <<<EOD
DELETE FROM NO_NOV_CONCEPTO WHERE id_nov_ded_adic = $id_nov_dec_adic
EOD;
                $this->conn->execute($sql);


                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {


            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            $id_nov_dec_adic = $list_data_post[0]['id_nov_dec_adic'];

            //quitar la fecha de terminacion
            $sql = <<<EOD
update no_nov_ded_adic set fecha_fin = null, fecha_doc_cierre = null
    where id_nov_dec_adic = $id_nov_dec_adic
EOD;

            $this->conn->execute($sql);

            $this->conn->commit();
        }

        //accion update
        if ($Action == "UPDATE") {


            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();


            try {

                $id_nov_dec_adic = $list_data_post[0]['id_nov_dec_adic'];
                $id_tipo_doc = $list_data_post[0]['id_tipo_doc'];
                $num_doc = $list_data_post[0]['num_doc'];
                $fecha_fin = $list_data_post[0]['fecha_fin'];

                $sql = <<<EOD
SELECT * FROM NO_PERIODO WHERE estado = 1 and activo = 1 
EOD;
                $results = CN_TABLE::executeSQL($sql);

                $id_anhos = $results[0]['id_anhos'];
                $id_meses = $results[0]['id_meses'];
                $id_periodo = $results[0]['id_periodo'];
                $id_tipo_periodo = $results[0]['id_tipo_periodo'];

                $sql = <<<EOD
SELECT * FROM NO_TIPO_PERIODO WHERE ID_TIPO_PERIODO = $id_tipo_periodo 
EOD;
                $results = CN_TABLE::executeSQL($sql);

                $num_dias = $results[0]['no_dias_mes'];


                $sql = <<<EOD
SELECT * FROM NO_NOV_CONCEPTO WHERE ID_NOV_DED_ADIC = $id_nov_dec_adic 
EOD;
                $results = CN_TABLE::executeSQL($sql);


                if (count($results) > 0) {

                    foreach ($results as $conceptos) {

                        $id_concep_nomina = $conceptos['id_concep_nomina'];

                        $sql = <<<EOD
update NO_CONCEPTO_FUNC tab0 set estado = 0, actual = 0, 
    fecha_hasta = to_date('$fecha_fin','YYYY-MM-DD') 
            where tab0.id_concep_nomina = $id_concep_nomina 
                and tab0.id_tipo_doc = $id_tipo_doc and tab0.num_doc = $num_doc
                and estado = 1 and actual = 1
EOD;

                        $this->conn->execute($sql);


                        //Dias para vacaciones 
                        //Toma los dias de vacaciones para el mes a liquidar - 20160114
                        //Sql
                        $sql = <<<EOD
select  nvl(num_dias_vac,0) as dias_vac from (    
   select 
     novvac.id_tipo_doc,                  
     novvac.num_doc,
     nvl(sum(dias_rango_mes(novvac.fecha_ini,novvac.fecha_fin,(select id_meses 
         from no_periodo where id_periodo =  $id_periodo))),0) as dias,
     nvl(sum( novvac.fecha_fin - novvac.fecha_ini + 1),0) as dias_vac,
     nvl(sum(DIAS_RANGO_MES_SIN_TREINTAYUNO(novvac.fecha_ini,novvac.fecha_fin,(select id_meses from no_periodo where id_periodo =  $id_periodo))),0) as num_dias_vac
     from no_novedad_vac novvac
     left join NO_TIPO_NOV_VAC TIPNOV on TIPNOV.ID_TIPO_NOV_VAC = NOVVAC.ID_TIPO_NOV_VAC
     where TIPNOV.TIEMPO_LIQUI = 1 
     --and NOVVAC.ID_PERIODO = $id_periodo
     and (
             novvac.fecha_ini between to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo) ,'dd/mm/yyyy')
             and trunc(last_day( to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo) ,'dd/mm/yyyy') )) 
             or
             novvac.fecha_fin between to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo) ,'dd/mm/yyyy')
             and TRUNC(LAST_DAY( TO_DATE('01/'|| (select LPAD(ID_MESES,2,'0') ||'/'||ID_ANHOS from NO_PERIODO where ID_PERIODO = $id_periodo) ,'dd/mm/yyyy') )) 

             or        


             to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo) ,'dd/mm/yyyy') between novvac.fecha_ini and novvac.fecha_fin
             or
             trunc(last_day( to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo) ,'dd/mm/yyyy') )) between novvac.fecha_ini and novvac.fecha_fin
    )
     and novvac.NUM_DOC = $num_doc
     group by novvac.id_tipo_doc, novvac.num_doc
)
EOD;

                        //Ejecutar SQL
                        $record_vac = CN_TABLE::executeSQL($sql);

                        /*
                         * Calcular IBC para vacaciones
                         */
                        // Toma los dias de vacaciones para el mes a liquidar
                        $wdiasv = 0;
                        if (count($record_vac) > 0) {
                            $wdiasv = $record_vac[0]['dias_vac'];
                        }

                        //num_dias = ( case when to_date('$fecha_fin','YYYY-MM-DD') - fecha_desde + 1 - $wdiasv < 0 then 0 else to_date('$fecha_fin','YYYY-MM-DD') - fecha_desde + 1 - $wdiasv end ) 
                        //meses de 30 - 20160218
                        //Validacion si es en fechas anteriores al periodo actual - 20160616
                        //Validacion para el porcentaje para que quite el porcentaje si no tiene dias - 20190319
                        $sql = <<<EOD
update NO_CONCEPTO_PERIODO tab0 set 
    porcentaje = case when to_date('$fecha_fin','YYYY-MM-DD') < fecha_desde then null else porcentaje end 
    ,fecha_hasta = case  
    when  to_date('$fecha_fin','YYYY-MM-DD') < fecha_desde then to_date('$fecha_fin','YYYY-MM-DD') 
    when to_char(fecha_hasta,'mm') != to_char(to_date('$fecha_fin','YYYY-MM-DD'),'mm') then fecha_hasta else to_date('$fecha_fin','YYYY-MM-DD') end
 
    --,num_dias = ( case when to_date('$fecha_fin','YYYY-MM-DD') - fecha_desde + 1 - 0 < 0 then 0 else to_date('$fecha_fin','YYYY-MM-DD') - fecha_desde + 1 - 0 end )
    ,num_dias = ( 
    
      case 
            when  to_date('$fecha_fin','YYYY-MM-DD') < fecha_desde
            then 0
            when  to_char(to_date('$fecha_fin','YYYY-MM-DD'),'mm') = to_char(fecha_desde,'mm')
            then case when to_date('$fecha_fin','YYYY-MM-DD') - fecha_desde + 1 - 0 < 0 then 0 else to_date('$fecha_fin','YYYY-MM-DD') - fecha_desde + 1 - 0 end 
            else 30 - to_number(to_char(fecha_desde,'dd')) + 1 end    
    
    )
            where tab0.id_concep_nomina = $id_concep_nomina and tab0.periodo = $id_periodo 
                and tab0.id_tipo_doc = $id_tipo_doc and tab0.num_doc = $num_doc
EOD;
                        $this->conn->execute($sql);
                    }
                }

                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
